﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinDock;
using System.Diagnostics;
using System.Windows.Forms;
using System.Drawing;

namespace _90719
{
    class MyCreation:IUIElementCreationFilter
    {
        public class RestoreInformation
        {
            public Point location;
            public Size PrevSize;
        }
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
           
            PaneCaptionButtonUIElement mbutton = parent as PaneCaptionButtonUIElement;

            if (mbutton != null && mbutton.PaneButtonType == PaneButton.Maximize
                && ((PaneUIElement)mbutton.Parent.Parent).Pane.DockedState == DockedState.Floating)
            {
                ButtonUIElement button = new ButtonUIElement(parent);
                button.Rect = new System.Drawing.Rectangle(mbutton.Rect.Location.X, mbutton.Rect.Location.Y, 15, 15);
                button.ElementClick += new UIElementEventHandler(button_ElementClick);
                parent.ChildElements.Add(button);
            }
        }

        void button_ElementClick(object sender, UIElementEventArgs e)
        {
            DockableWindow window = (DockableWindow)sender;
            RestoreInformation resInfo = new RestoreInformation();
            resInfo.location = window.Parent.Parent.Location;
            resInfo.PrevSize = window.Parent.Size;
            
            Screen sc = Screen.FromControl((e.Element).Control);
            Size newSize = new System.Drawing.Size(sc.WorkingArea.Size.Width - 10, sc.WorkingArea.Size.Height - 10);
            if (window.Tag is RestoreInformation && window.Parent.Size == newSize
                && window.Parent.Parent.Location == sc.WorkingArea.Location)
            {
                window.Parent.Size = ((RestoreInformation)window.Tag).PrevSize;
                window.Parent.Parent.Location = ((RestoreInformation)window.Tag).location;
            }
            else
            {
                window.Parent.Size = newSize;
                window.Parent.Parent.Location = sc.WorkingArea.Location;
                window.Tag = resInfo;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }
}
